﻿'Pen-O-Mathic catches the Output of Math Input Panel from the clipboard
'and parses it to Latex Code, which is stored back to the clipboard.
'Copyright (C) 2010 Thomas Pöperny, penomathic@nib.cc

'This program is free software: you can redistribute it and/or modify
'it under the terms of the GNU General Public License as published by
'the Free Software Foundation, either version 3 of the License, or
'(at your option) any later version.

'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.

'You should have received a copy of the GNU General Public License
'along with this program.  If not, see <http://www.gnu.org/licenses/>.

Imports System
Imports System.IO
Imports System.Text
Imports System.Text.RegularExpressions
Public Class Form1
    Public LatexString As String
    Public InpStr As String
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

    End Sub
    Private Sub LoadMMLCode()
        Dim memStream As New MemoryStream(100)

        Dim dataObj As IDataObject = Clipboard.GetDataObject()
        If dataObj.GetDataPresent("MathML") Then 'bekommt einen system.io.memorystream

            memStream = CType(dataObj.GetData("MathML"), MemoryStream)
            
        End If

        Dim count As Integer
        Dim byteArray As Byte()
        Dim charArray As Char()
        Dim uniEncoding As New UnicodeEncoding()

       

        Try
            
            memStream.Seek(0, SeekOrigin.Begin)


            byteArray = New Byte(CType(memStream.Length, Integer)) {}
            count = memStream.Read(byteArray, 0, 1)


            While (count < memStream.Length)
                byteArray(count) = Convert.ToByte(memStream.ReadByte())
                count += 1
            End While

            
            charArray = New Char(uniEncoding.GetCharCount(byteArray, 0, count)) {}
            uniEncoding.GetDecoder().GetChars(byteArray, 0, count, charArray, 0)
            

            InpStr = CType(charArray, String)
        Finally
            memStream.Close()
        End Try
    End Sub


    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click

        Dim dataObj As IDataObject = Clipboard.GetDataObject()
        If dataObj.GetDataPresent("MathML") Then 'bekommt einen system.io.memorystream
            LoadMMLCode()
            LatexString = CropString(InpStr)
            LatexString = ParseCodeToLatex(LatexString)
            LatexString = LatexString.Remove(LatexString.Length - 3)
            My.Computer.Clipboard.SetText(LatexString)
        End If
        
    End Sub
    Function CropString(ByVal CString As String) As String
        Dim RHeader As New Regex("\<\?.+mathrecognizer\W\s\>")
        CString = RHeader.Replace(CString, "")
        CString = CString.Remove(0, 1)
        Dim RMathFooter As New Regex("\<...math\>")
        CString = RMathFooter.Replace(CString, "")
        Return CString
    End Function
    Function ParseCodeToLatex(ByVal MString As String, Optional ByVal TagNr As Integer = 0)
        If MString = "" Then Return MString
        Dim WorkString As String
        Dim MStringBuffer As String
        WorkString = MString
        Dim rErstesTag As New Regex("\<m\:(?<1>\w+.*?)\>")
        Dim mErstesTag As Match
        mErstesTag = rErstesTag.Match(WorkString)
        Dim sErstesTag As String = ""
        If mErstesTag.Success Then
            sErstesTag = mErstesTag.Result("${1}")
        Else
            sErstesTag = ""
        End If

        Dim rErstesTagWord As New Regex("(\w+)")
        Dim mErstesTagWord As Match
        mErstesTagWord = rErstesTagWord.Match(sErstesTag)
        Dim sErstesTagWord As String = ""
        If mErstesTagWord.Success Then
            sErstesTagWord = mErstesTagWord.Result("${1}")
        Else
            sErstesTagWord = ""
        End If

        Dim rFolgeTagsExpr As String
        rFolgeTagsExpr = "\<m\:(" & sErstesTagWord & ")"
        Dim rFolgeTags As New Regex(rFolgeTagsExpr)
        Dim mFolgeTags As Match
        mFolgeTags = rFolgeTags.Match(WorkString)

        Dim CounterOTags(0) As Integer
        Dim OT As Integer = 0
        Do While mFolgeTags.Success
            ReDim Preserve CounterOTags(OT)
            CounterOTags(OT) = mFolgeTags.Groups(1).Index
            mFolgeTags = mFolgeTags.NextMatch
            OT += 1
        Loop

        Dim rClosingTagsExpr As String
        rClosingTagsExpr = "\<\/\w+\:(" & sErstesTagWord & ")\>"
        Dim rClosingTags As New Regex(rClosingTagsExpr)
        Dim mClosingTags As Match
        mClosingTags = rClosingTags.Match(WorkString)

        Dim CounterCTags(0) As Integer
        Dim CT As Integer = 0
        Do While mClosingTags.Success
            ReDim Preserve CounterCTags(CT)
            CounterCTags(CT) = mClosingTags.Groups(1).Index
            mClosingTags = mClosingTags.NextMatch
            CT += 1
        Loop

        Dim CutMarkerEnd As Integer
        For i = 0 To CounterCTags.GetUpperBound(0)
            If i = CounterCTags.GetUpperBound(0) Then
                CutMarkerEnd = CounterCTags(i)
                Exit For
            End If
            If CounterCTags(i) > CounterOTags(i) And CounterCTags(i) < CounterOTags(i + 1) Then
                CutMarkerEnd = CounterCTags(i)
                Exit For
            End If
        Next i

        Dim TagNrCounter As Integer
        TagNrCounter = TagNr

        Do While TagNrCounter > 1
            MString = MString.Remove(CounterOTags(0) - 3, CutMarkerEnd + sErstesTagWord.Length + 1)
            WorkString = MString
            mErstesTag = rErstesTag.Match(WorkString)


            If mErstesTag.Success Then
                sErstesTag = mErstesTag.Result("${1}")
            Else
                sErstesTag = ""
            End If

            mErstesTagWord = rErstesTagWord.Match(sErstesTag)

            If mErstesTagWord.Success Then
                sErstesTagWord = mErstesTagWord.Result("${1}")
            Else
                sErstesTagWord = ""
            End If

            rFolgeTagsExpr = "\<m\:(" & sErstesTagWord & ")"
            rFolgeTags = New Regex(rFolgeTagsExpr)
            mFolgeTags = rFolgeTags.Match(WorkString)

            OT = 0
            Do While mFolgeTags.Success
                ReDim Preserve CounterOTags(OT)
                CounterOTags(OT) = mFolgeTags.Groups(1).Index
                mFolgeTags = mFolgeTags.NextMatch
                OT += 1
            Loop

            rClosingTagsExpr = "\<\/\w+\:(" & sErstesTagWord & ")\>"
            rClosingTags = New Regex(rClosingTagsExpr)
            mClosingTags = rClosingTags.Match(WorkString)

            CT = 0
            Do While mClosingTags.Success
                ReDim Preserve CounterCTags(CT)
                CounterCTags(CT) = mClosingTags.Groups(1).Index
                mClosingTags = mClosingTags.NextMatch
                CT += 1
            Loop

            For i = 0 To CounterCTags.GetUpperBound(0)
                If i = CounterCTags.GetUpperBound(0) Then
                    CutMarkerEnd = CounterCTags(i)
                    Exit For
                End If
                If CounterCTags(i) > CounterOTags(i) And CounterCTags(i) < CounterOTags(i + 1) Then
                    CutMarkerEnd = CounterCTags(i)
                    Exit For
                End If
            Next i

            TagNrCounter -= 1

        Loop

        Select Case sErstesTag
            Case "mi"
                MString = WorkString.Remove(CutMarkerEnd - 4)
                MString = MString.Remove(CounterOTags(0) - 3, sErstesTag.Length + 4)
                WorkString = WorkString.Remove(CounterOTags(0) - 3, CutMarkerEnd + sErstesTagWord.Length + 1)
                Select Case TagNr
                    Case 0
                        MString = ParseCodeToLatex(MString) & ParseCodeToLatex(WorkString)
                    Case 1, 2, 3
                        MString = ParseCodeToLatex(MString)
                End Select

            Case "mfenced open=" & Chr(34) & "(" & Chr(34) & " close=" & Chr(34) & ")" & Chr(34) & ""
                MString = WorkString.Remove(CutMarkerEnd - 4)
                MString = MString.Remove(CounterOTags(0) - 3, sErstesTag.Length + 4)
                WorkString = WorkString.Remove(CounterOTags(0) - 3, CutMarkerEnd + sErstesTagWord.Length + 1)
                Select Case TagNr
                    Case 0
                        MString = "\left(" & ParseCodeToLatex(MString) & "\right)" & ParseCodeToLatex(WorkString)
                    Case 1, 2, 3
                        MString = "\left(" & ParseCodeToLatex(MString) & "\right)"
                End Select

            Case "mrow"
                MString = WorkString.Remove(CutMarkerEnd - 4)
                MString = MString.Remove(CounterOTags(0) - 3, sErstesTag.Length + 4)
                WorkString = WorkString.Remove(CounterOTags(0) - 3, CutMarkerEnd + sErstesTagWord.Length + 1)
                Select Case TagNr
                    Case 0
                        MString = ParseCodeToLatex(MString) & ParseCodeToLatex(WorkString)
                    Case 1, 2, 3
                        MString = ParseCodeToLatex(MString)
                End Select

            Case "msqrt"
                MString = WorkString.Remove(CutMarkerEnd - 4)
                MString = MString.Remove(CounterOTags(0) - 3, sErstesTag.Length + 4)
                WorkString = WorkString.Remove(CounterOTags(0) - 3, CutMarkerEnd + sErstesTagWord.Length + 1)
                Select Case TagNr
                    Case 0
                        MString = "\sqrt{" & ParseCodeToLatex(MString) & "}" & ParseCodeToLatex(WorkString)
                    Case 1, 2, 3
                        MString = "\sqrt{" & ParseCodeToLatex(MString) & "}"
                End Select

            Case "mn"
                MString = WorkString.Remove(CutMarkerEnd - 4)
                MString = MString.Remove(CounterOTags(0) - 3, sErstesTag.Length + 4)
                WorkString = WorkString.Remove(CounterOTags(0) - 3, CutMarkerEnd + sErstesTagWord.Length + 1)
                Select Case TagNr
                    Case 0
                        MString = ParseCodeToLatex(MString) & ParseCodeToLatex(WorkString)
                    Case 1, 2, 3
                        MString = ParseCodeToLatex(MString)
                End Select
            Case "mo", "mo stretchy=" & Chr(34) & "true" & Chr(34) & " accent=" & Chr(34) & "true" & Chr(34)
                MString = WorkString.Remove(CutMarkerEnd - 4)
                MString = MString.Remove(CounterOTags(0) - 3, sErstesTag.Length + 4)
                WorkString = WorkString.Remove(CounterOTags(0) - 3, CutMarkerEnd + sErstesTagWord.Length + 1)
                Select Case TagNr
                    Case 0
                        MString = ParseCodeToLatex(MString) & ParseCodeToLatex(WorkString)
                    Case 1, 2, 3
                        MString = ParseCodeToLatex(MString)
                End Select

            Case "msubsup"
                MString = WorkString.Remove(CutMarkerEnd - 4)
                MString = MString.Remove(0, sErstesTag.Length + 4)
                WorkString = WorkString.Remove(0, CutMarkerEnd + sErstesTagWord.Length + 1)
                MStringBuffer = MString
                Select Case TagNr
                    Case 0
                        MString = ParseCodeToLatex(MString, 1) & "_{" & ParseCodeToLatex(MString, 2) & "}^{" & ParseCodeToLatex(MString, 3) & "}" & ParseCodeToLatex(WorkString)
                    Case 1, 2, 3
                        MString = ParseCodeToLatex(MString, 1) & "_{" & ParseCodeToLatex(MString, 2) & "}^" & ParseCodeToLatex(MString, 3) & "}"
                End Select
                
            Case "munderover"
                MString = WorkString.Remove(CutMarkerEnd - 4)
                MString = MString.Remove(0, sErstesTag.Length + 4)

                WorkString = WorkString.Remove(0, CutMarkerEnd + sErstesTagWord.Length + 1)
                MStringBuffer = MString
                Select Case ParseCodeToLatex(MString, 1)
                    Case ChrW(8747)
                        Select Case TagNr
                            Case 0
                                MString = "\int \limits_{" & ParseCodeToLatex(MString, 2) & "}^{" & ParseCodeToLatex(MString, 3) & "} " & ParseCodeToLatex(WorkString)

                            Case 1, 2, 3
                                MString = "\int \limits_{" & ParseCodeToLatex(MString, 2) & "}^{" & ParseCodeToLatex(MString, 3) & "} "
                        End Select
                    Case ChrW(8748)
                        Select Case TagNr
                            Case 0
                                MString = "\iint \limits_{" & ParseCodeToLatex(MString, 2) & "}^{" & ParseCodeToLatex(MString, 3) & "} " & ParseCodeToLatex(WorkString)

                            Case 1, 2, 3
                                MString = "\iint \limits_{" & ParseCodeToLatex(MString, 2) & "}^{" & ParseCodeToLatex(MString, 3) & "} "
                        End Select
                    Case ChrW(8749)
                        Select Case TagNr
                            Case 0
                                MString = "\iiint \limits_{" & ParseCodeToLatex(MString, 2) & "}^{" & ParseCodeToLatex(MString, 3) & "} " & ParseCodeToLatex(WorkString)

                            Case 1, 2, 3
                                MString = "\iiint \limits_{" & ParseCodeToLatex(MString, 2) & "}^{" & ParseCodeToLatex(MString, 3) & "} "
                        End Select
                    Case ChrW(8750)
                        Select Case TagNr
                            Case 0
                                MString = "\oint \limits_{" & ParseCodeToLatex(MString, 2) & "}^{" & ParseCodeToLatex(MString, 3) & "} " & ParseCodeToLatex(WorkString)

                            Case 1, 2, 3
                                MString = "\oint \limits_{" & ParseCodeToLatex(MString, 2) & "}^{" & ParseCodeToLatex(MString, 3) & "} "
                        End Select
                        '---------------was sind die befehle für oii und oiii???
                        'Case ChrW(8751)
                        '    Select Case TagNr
                        '        Case 0
                        '            MString = "\oiint \limits_{" & ParseCodeToLatex(MString, 2) & "}^{" & ParseCodeToLatex(MString, 3) & "} " & ParseCodeToLatex(WorkString)

                        '        Case 1, 2, 3
                        '            MString = "\oiint \limits_{" & ParseCodeToLatex(MString, 2) & "}^{" & ParseCodeToLatex(MString, 3) & "} "
                        '    End Select
                        'Case ChrW(8752)
                        '    Select Case TagNr
                        '        Case 0
                        '            MString = "\oiiint \limits_{" & ParseCodeToLatex(MString, 2) & "}^{" & ParseCodeToLatex(MString, 3) & "} " & ParseCodeToLatex(WorkString)

                        '        Case 1, 2, 3
                        '            MString = "\oiiint \limits_{" & ParseCodeToLatex(MString, 2) & "}^{" & ParseCodeToLatex(MString, 3) & "} "
                        '    End Select
                    Case ChrW(8721)
                        Select Case TagNr
                            Case 0
                                MString = "\sum \limits_{" & ParseCodeToLatex(MString, 2) & "}^{" & ParseCodeToLatex(MString, 3) & "} " & ParseCodeToLatex(WorkString)

                            Case 1, 2, 3
                                MString = "\sum \limits_{" & ParseCodeToLatex(MString, 2) & "}^{" & ParseCodeToLatex(MString, 3) & "} "
                        End Select
                End Select
                
            Case "msup"
                MString = WorkString.Remove(CutMarkerEnd - 4)
                MString = MString.Remove(0, sErstesTag.Length + 4)
                WorkString = WorkString.Remove(0, CutMarkerEnd + sErstesTagWord.Length + 1)
                Select Case TagNr
                    Case 0
                        MString = ParseCodeToLatex(MString, 1) & "^{" & ParseCodeToLatex(MString, 2) & "}" & ParseCodeToLatex(WorkString)
                    Case 1, 2, 3
                        MString = ParseCodeToLatex(MString, 1) & "^{" & ParseCodeToLatex(MString, 2) & "}"
                End Select
            Case "munder"
                MString = WorkString.Remove(CutMarkerEnd - 4)
                MString = MString.Remove(0, sErstesTag.Length + 4)
                WorkString = WorkString.Remove(0, CutMarkerEnd + sErstesTagWord.Length + 1)
                Select Case TagNr
                    Case 0
                        MString = ParseCodeToLatex(MString, 1) & " \limits_{" & ParseCodeToLatex(MString, 2) & "} " & ParseCodeToLatex(WorkString)
                    Case 1, 2, 3
                        MString = ParseCodeToLatex(MString, 1) & " \limits_{" & ParseCodeToLatex(MString, 2) & "} "
                End Select
            Case "mo mathvariant=" & Chr(34) & "normal" & Chr(34)
                MString = WorkString.Remove(CutMarkerEnd - 4)
                MString = MString.Remove(0, sErstesTag.Length + 4)
                WorkString = WorkString.Remove(0, CutMarkerEnd + sErstesTagWord.Length + 1)
                Select Case ParseCodeToLatex(MString)
                    Case "cos"
                        Select Case TagNr
                            Case 0
                                MString = "\cos " & ParseCodeToLatex(WorkString)
                            Case 1, 2, 3
                                MString = "\cos "
                        End Select
                    Case "arccos"
                        Select Case TagNr
                            Case 0
                                MString = "\arccos " & ParseCodeToLatex(WorkString)
                            Case 1, 2, 3
                                MString = "\arccos "
                        End Select
                    Case "tanh"
                        Select Case TagNr
                            Case 0
                                MString = "\tanh " & ParseCodeToLatex(WorkString)
                            Case 1, 2, 3
                                MString = "\tanh "
                        End Select
                    Case "sin"
                        Select Case TagNr
                            Case 0
                                MString = "\sin " & ParseCodeToLatex(WorkString)
                            Case 1, 2, 3
                                MString = "\sin "
                        End Select
                    Case "tan"
                        Select Case TagNr
                            Case 0
                                MString = "\tan " & ParseCodeToLatex(WorkString)
                            Case 1, 2, 3
                                MString = "\tan "
                        End Select
                End Select
                
            Case "mover accent=" & Chr(34) & "true" & Chr(34), "mover", "mover stretchy=" & Chr(34) & "true" & Chr(34) & " accent=" & Chr(34) & "true" & Chr(34)
                MString = WorkString.Remove(CutMarkerEnd - 4)
                MString = MString.Remove(0, sErstesTag.Length + 4)
                WorkString = WorkString.Remove(0, CutMarkerEnd + sErstesTagWord.Length + 1)
                Select Case ParseCodeToLatex(MString, 2)
                    Case ChrW(8594)
                        Select Case TagNr
                            Case 0
                                MString = "\vec{" & ParseCodeToLatex(MString, 1) & "}" & ParseCodeToLatex(WorkString)
                            Case 1, 2, 3
                                MString = "\vec{" & ParseCodeToLatex(MString, 1) & "}"
                        End Select
                    Case "^"
                        Select Case TagNr
                            Case 0
                                MString = "\hat{" & ParseCodeToLatex(MString, 1) & "}" & ParseCodeToLatex(WorkString)
                            Case 1, 2, 3
                                MString = "\hat{" & ParseCodeToLatex(MString, 1) & "}"
                        End Select
                    Case "~"
                        Select Case TagNr
                            Case 0
                                MString = "\tilde{" & ParseCodeToLatex(MString, 1) & "}" & ParseCodeToLatex(WorkString)
                            Case 1, 2, 3
                                MString = "\tilde{" & ParseCodeToLatex(MString, 1) & "}"
                        End Select
                    Case "¨"
                        Select Case TagNr
                            Case 0
                                MString = "\ddot{" & ParseCodeToLatex(MString, 1) & "}" & ParseCodeToLatex(WorkString)
                            Case 1, 2, 3
                                MString = "\ddot{" & ParseCodeToLatex(MString, 1) & "}"
                        End Select
                    Case "."
                        Select Case TagNr
                            Case 0
                                MString = "\dot{" & ParseCodeToLatex(MString, 1) & "}" & ParseCodeToLatex(WorkString)
                            Case 1, 2, 3
                                MString = "\dot{" & ParseCodeToLatex(MString, 1) & "}"
                        End Select
                    Case "-"
                        Select Case TagNr
                            Case 0
                                MString = "\bar{" & ParseCodeToLatex(MString, 1) & "}" & ParseCodeToLatex(WorkString)
                            Case 1, 2, 3
                                MString = "\bar{" & ParseCodeToLatex(MString, 1) & "}"
                        End Select
                End Select
                
            Case "msub"
                MString = WorkString.Remove(CutMarkerEnd - 4)
                MString = MString.Remove(0, sErstesTag.Length + 4)
                WorkString = WorkString.Remove(0, CutMarkerEnd + sErstesTagWord.Length + 1)
                Select Case TagNr
                    Case 0
                        MString = ParseCodeToLatex(MString, 1) & "_{" & ParseCodeToLatex(MString, 2) & "}" & ParseCodeToLatex(WorkString)
                    Case 1, 2, 3
                        MString = ParseCodeToLatex(MString, 1) & "_{" & ParseCodeToLatex(MString, 2) & "}"
                End Select

            Case "mfrac"
                MString = WorkString.Remove(CutMarkerEnd - 4)
                MString = MString.Remove(0, sErstesTag.Length + 4)
                WorkString = WorkString.Remove(0, CutMarkerEnd + sErstesTagWord.Length + 1)
                Select Case TagNr
                    Case 0
                        MString = "\frac{" & ParseCodeToLatex(MString, 1) & "}{" & ParseCodeToLatex(MString, 2) & "}" & ParseCodeToLatex(WorkString)
                    Case 1, 2, 3
                        MString = "\frac{" & ParseCodeToLatex(MString, 1) & "}{" & ParseCodeToLatex(MString, 2) & "}"
                End Select
            Case "mroot"
                MString = WorkString.Remove(CutMarkerEnd - 4)
                MString = MString.Remove(0, sErstesTag.Length + 4)
                WorkString = WorkString.Remove(0, CutMarkerEnd + sErstesTagWord.Length + 1)
                Select Case TagNr
                    Case 0
                        MString = "\sqrt[" & ParseCodeToLatex(MString, 2) & "]{" & ParseCodeToLatex(MString, 1) & "}" & ParseCodeToLatex(WorkString)
                    Case 1, 2, 3
                        MString = "\sqrt[" & ParseCodeToLatex(MString, 2) & "]{" & ParseCodeToLatex(MString, 1) & "}"
                End Select
            Case "mtd"
                MString = WorkString.Remove(CutMarkerEnd - 4)
                MString = MString.Remove(0, sErstesTag.Length + 4)
                WorkString = WorkString.Remove(0, CutMarkerEnd + sErstesTagWord.Length + 1)
                Select Case TagNr
                    Case 0
                        MString = ParseCodeToLatex(MString) & "&" & ParseCodeToLatex(WorkString)
                    Case 1, 2, 3
                        MString = ParseCodeToLatex(MString) & "&"
                End Select
            Case "mtr"
                MString = WorkString.Remove(CutMarkerEnd - 4)
                MString = MString.Remove(0, sErstesTag.Length + 4)
                WorkString = WorkString.Remove(0, CutMarkerEnd + sErstesTagWord.Length + 1)
                Select Case TagNr
                    Case 0
                        MString = ParseCodeToLatex(MString) & "\cr" & ParseCodeToLatex(WorkString)
                    Case 1, 2, 3
                        MString = ParseCodeToLatex(MString) & "\cr"
                End Select
            Case "mtable"
                MString = WorkString.Remove(CutMarkerEnd - 4)
                MString = MString.Remove(0, sErstesTag.Length + 4)
                WorkString = WorkString.Remove(0, CutMarkerEnd + sErstesTagWord.Length + 1)
                Select Case TagNr
                    Case 0
                        MString = "\matrix{" & ParseCodeToLatex(MString) & "}" & ParseCodeToLatex(WorkString)
                    Case 1, 2, 3
                        MString = "\matrix{" & ParseCodeToLatex(MString) & "}"
                End Select
            Case Else

                Dim oChar As String = MString
                If oChar.Length > 1 Then
                    oChar = oChar.Remove(1)
                End If

                Select Case oChar
                    Case "l"
                        If MString = "lim" Then
                            MString = "\lim "
                        End If
                        'Case ChrW(8747)
                        '    MString = "\int"
                    Case ChrW(176)
                        MString = "^\circ "
                    Case ChrW(177)
                        MString = "\pm "
                    Case ChrW(8734)
                        MString = "\infty "
                    Case ChrW(8289)
                        MString = ""
                    Case ChrW(8518)
                        MString = "d"
                    Case ChrW(945)
                        MString = "\alpha "
                    Case ChrW(946)
                        MString = "\beta "
                    Case ChrW(967)
                        MString = "\chi "
                    Case ChrW(948)
                        MString = "\delta "
                    Case ChrW(949)
                        MString = "\epsilon "
                    Case ChrW(981)
                        MString = "\phi "
                    Case ChrW(966)
                        MString = "\varphi "
                    Case ChrW(947)
                        MString = "\gamma "
                    Case ChrW(951)
                        MString = "\eta "
                    Case ChrW(953)
                        MString = "\iota "
                    Case ChrW(954)
                        MString = "\kappa "
                    Case ChrW(955)
                        MString = "\lambda "
                    Case ChrW(956)
                        MString = "\mu "
                    Case ChrW(957)
                        MString = "\nu "
                    Case ChrW(960)
                        MString = "\pi "
                    Case ChrW(952)
                        MString = "\theta "
                    Case ChrW(977)
                        MString = "\vartheta "
                    Case ChrW(961)
                        MString = "\rho "
                    Case ChrW(963)
                        MString = "\sigma "
                    Case ChrW(962)
                        MString = "\varsigma "
                    Case ChrW(964)
                        MString = "\tau "
                    Case ChrW(958)
                        MString = "\xi "
                    Case ChrW(969)
                        MString = "\omega "
                    Case ChrW(968)
                        MString = "\psi "
                    Case ChrW(950)
                        MString = "\zeta "
                    Case ChrW(916)
                        MString = "\Delta "
                    Case ChrW(934)
                        MString = "\Phi "
                    Case ChrW(915)
                        MString = "\Gamma "
                    Case ChrW(923)
                        MString = "\Lambda "
                    Case ChrW(928)
                        MString = "\Pi "
                    Case ChrW(920)
                        MString = "\Theta "
                    Case ChrW(931)
                        MString = "\Sigma "
                    Case ChrW(937)
                        MString = "\Omega "
                    Case ChrW(926)
                        MString = "\Xi "
                    Case ChrW(936)
                        MString = "\Psi "
                    Case ChrW(8804)
                        MString = "\leq "
                    Case ChrW(8805)
                        MString = "\geq "
                    Case ChrW(8810)
                        MString = "<<"
                    Case ChrW(8811)
                        MString = ">>"
                    Case ChrW(8704)
                        MString = "\forall "
                        '---------leere menge befehl?
                        'Case ChrW(8709)
                        '   MString = ""
                    Case ChrW(8707)
                        MString = "\exists "
                    Case ChrW(8519)
                        MString = "e"
                    Case ChrW(8520)
                        MString = "i"
                    Case ChrW(8594)
                        MString = "\rightarrow "
                    Case ChrW(8712)
                        MString = "\in "
                    Case ChrW(8715)
                        MString = "\ni "
                    Case ChrW(8713)
                        MString = "\notin "
                    Case ChrW(8463)
                        MString = "\hbar "
                    Case ChrW(8469)
                        MString = "\mathbb{N}"
                    Case ChrW(8450)
                        MString = "\mathbb{C}"
                    Case ChrW(8484)
                        MString = "\mathbb{Z}"
                    Case ChrW(8474)
                        MString = "\mathbb{Q}"
                    Case ChrW(8477)
                        MString = "\mathbb{R}"
                    Case ChrW(8834)
                        MString = "\subset "
                    Case ChrW(8835)
                        MString = "\supset "
                    Case ChrW(8838)
                        MString = "\subseteq "
                    Case ChrW(8839)
                        MString = "\supseteq "
                    Case ChrW(8745)
                        MString = "\cup "
                    Case ChrW(8746)
                        MString = "\cap "
                    Case ChrW(172)
                        MString = "\neg "
                    Case ChrW(8801)
                        MString = "\equiv "
                    Case ChrW(8776)
                        MString = "\approx "
                    Case ChrW(8773)
                        MString = "\cong "
                    Case ChrW(8733)
                        MString = "\propto "
                    Case ChrW(8800)
                        MString = "\neq "
                    Case ChrW(8901)
                        MString = "\cdot "
                    Case ChrW(215)
                        MString = "\times "
                    Case ChrW(8658)
                        MString = "\Rightarrow "
                    Case ChrW(8656)
                        MString = "\Leftarrow "
                    Case ChrW(8660)
                        MString = "\Leftrightarrow "
                    Case ChrW(8614)
                        MString = "\mapsto "
                    Case ChrW(8737)
                        MString = "\measuredangle "
                    Case ChrW(8706)
                        MString = "\partial "
                    Case ChrW(8711)
                        MString = "\nabla "
                    Case "&"
                        Select Case MString

                            Case "&lt;"
                                MString = "<"
                            Case "&gt;"
                                MString = ">"

                        End Select
                End Select
                Return MString
        End Select

        Return MString

    End Function
    Function ParseCodeToMML(ByVal MString As String, Optional ByVal TagNr As Integer = 0)
        'MString = MString.Remove(MString.Length - 3)
        'MString = "<?xml version=" & Chr(34) & "1.0" & Chr(34) & " encoding=" & Chr(34) & "UTF-8" & Chr(34) & "?><!DOCTYPE math:math PUBLIC " & Chr(34) & "-//OpenOffice.org//DTD Modified W3C MathML 1.01//EN" & Chr(34) & " " & Chr(34) & "math.dtd" & Chr(34) & "><math:math xmlns:math=" & Chr(34) & "http://www.w3.org/1998/Math/MathML" & Chr(34) & "><math:semantics>" & MString & "</math:semantics></math:math>"
        'Dim rMMLOTags As New Regex("\<m\:")
        'Dim rMMLCTags As New Regex("\<\/m\:")
        'MString = rMMLOTags.Replace(MString, "<math:")
        'MString = rMMLCTags.Replace(MString, "</math:")
        '------------------------------------------
        If MString = "" Then Return MString
        Dim WorkString As String
        Dim MStringBuffer As String
        WorkString = MString
        Dim rErstesTag As New Regex("\<m\:(?<1>\w+.*?)\>")
        Dim mErstesTag As Match
        mErstesTag = rErstesTag.Match(WorkString)
        Dim sErstesTag As String = ""
        If mErstesTag.Success Then
            sErstesTag = mErstesTag.Result("${1}")
        Else
            sErstesTag = ""
        End If

        Dim rErstesTagWord As New Regex("(\w+)")
        Dim mErstesTagWord As Match
        mErstesTagWord = rErstesTagWord.Match(sErstesTag)
        Dim sErstesTagWord As String = ""
        If mErstesTagWord.Success Then
            sErstesTagWord = mErstesTagWord.Result("${1}")
        Else
            sErstesTagWord = ""
        End If

        Dim rFolgeTagsExpr As String
        rFolgeTagsExpr = "\<m\:(" & sErstesTagWord & ")"
        Dim rFolgeTags As New Regex(rFolgeTagsExpr)
        Dim mFolgeTags As Match
        mFolgeTags = rFolgeTags.Match(WorkString)

        Dim CounterOTags(0) As Integer
        Dim OT As Integer = 0
        Do While mFolgeTags.Success
            ReDim Preserve CounterOTags(OT)
            CounterOTags(OT) = mFolgeTags.Groups(1).Index
            mFolgeTags = mFolgeTags.NextMatch
            OT += 1
        Loop

        Dim rClosingTagsExpr As String
        rClosingTagsExpr = "\<\/\w+\:(" & sErstesTagWord & ")\>"
        Dim rClosingTags As New Regex(rClosingTagsExpr)
        Dim mClosingTags As Match
        mClosingTags = rClosingTags.Match(WorkString)

        Dim CounterCTags(0) As Integer
        Dim CT As Integer = 0
        Do While mClosingTags.Success
            ReDim Preserve CounterCTags(CT)
            CounterCTags(CT) = mClosingTags.Groups(1).Index
            mClosingTags = mClosingTags.NextMatch
            CT += 1
        Loop

        Dim CutMarkerEnd As Integer
        For i = 0 To CounterCTags.GetUpperBound(0)
            If i = CounterCTags.GetUpperBound(0) Then
                CutMarkerEnd = CounterCTags(i)
                Exit For
            End If
            If CounterCTags(i) > CounterOTags(i) And CounterCTags(i) < CounterOTags(i + 1) Then
                CutMarkerEnd = CounterCTags(i)
                Exit For
            End If
        Next i

        Dim TagNrCounter As Integer
        TagNrCounter = TagNr

        Do While TagNrCounter > 1
            MString = MString.Remove(CounterOTags(0) - 3, CutMarkerEnd + sErstesTagWord.Length + 1)
            WorkString = MString
            mErstesTag = rErstesTag.Match(WorkString)


            If mErstesTag.Success Then
                sErstesTag = mErstesTag.Result("${1}")
            Else
                sErstesTag = ""
            End If

            mErstesTagWord = rErstesTagWord.Match(sErstesTag)

            If mErstesTagWord.Success Then
                sErstesTagWord = mErstesTagWord.Result("${1}")
            Else
                sErstesTagWord = ""
            End If

            rFolgeTagsExpr = "\<m\:(" & sErstesTagWord & ")"
            rFolgeTags = New Regex(rFolgeTagsExpr)
            mFolgeTags = rFolgeTags.Match(WorkString)

            OT = 0
            Do While mFolgeTags.Success
                ReDim Preserve CounterOTags(OT)
                CounterOTags(OT) = mFolgeTags.Groups(1).Index
                mFolgeTags = mFolgeTags.NextMatch
                OT += 1
            Loop

            rClosingTagsExpr = "\<\/\w+\:(" & sErstesTagWord & ")\>"
            rClosingTags = New Regex(rClosingTagsExpr)
            mClosingTags = rClosingTags.Match(WorkString)

            CT = 0
            Do While mClosingTags.Success
                ReDim Preserve CounterCTags(CT)
                CounterCTags(CT) = mClosingTags.Groups(1).Index
                mClosingTags = mClosingTags.NextMatch
                CT += 1
            Loop

            For i = 0 To CounterCTags.GetUpperBound(0)
                If i = CounterCTags.GetUpperBound(0) Then
                    CutMarkerEnd = CounterCTags(i)
                    Exit For
                End If
                If CounterCTags(i) > CounterOTags(i) And CounterCTags(i) < CounterOTags(i + 1) Then
                    CutMarkerEnd = CounterCTags(i)
                    Exit For
                End If
            Next i

            TagNrCounter -= 1

        Loop

        Select Case sErstesTag
            Case "mi"
                MString = WorkString.Remove(CutMarkerEnd - 4)
                MString = MString.Remove(CounterOTags(0) - 3, sErstesTag.Length + 4)
                WorkString = WorkString.Remove(CounterOTags(0) - 3, CutMarkerEnd + sErstesTagWord.Length + 1)
                Select Case TagNr
                    Case 0
                        MString = ParseCodeToMML(MString) & ParseCodeToMML(WorkString)
                    Case 1, 2, 3
                        MString = ParseCodeToMML(MString)
                End Select

                '    Case "mfenced open=" & Chr(34) & "(" & Chr(34) & " close=" & Chr(34) & ")" & Chr(34) & ""
                '        MString = WorkString.Remove(CutMarkerEnd - 4)
                '        MString = MString.Remove(CounterOTags(0) - 3, sErstesTag.Length + 4)
                '        WorkString = WorkString.Remove(CounterOTags(0) - 3, CutMarkerEnd + sErstesTagWord.Length + 1)
                '        Select Case TagNr
                '            Case 0
                '                MString = "\left(" & parsecodetomml(MString) & "\right)" & parsecodetomml(WorkString)
                '            Case 1, 2, 3
                '                MString = "\left(" & parsecodetomml(MString) & "\right)"
                '        End Select

            Case "mrow"
                MString = WorkString.Remove(CutMarkerEnd - 4)
                MString = MString.Remove(CounterOTags(0) - 3, sErstesTag.Length + 4)
                WorkString = WorkString.Remove(CounterOTags(0) - 3, CutMarkerEnd + sErstesTagWord.Length + 1)
                Select Case TagNr
                    Case 0
                        MString = ParseCodeToMML(MString) & ParseCodeToMML(WorkString)
                    Case 1, 2, 3
                        MString = ParseCodeToMML(MString)
                End Select

            Case "msqrt"
                MString = WorkString.Remove(CutMarkerEnd - 4)
                MString = MString.Remove(CounterOTags(0) - 3, sErstesTag.Length + 4)
                WorkString = WorkString.Remove(CounterOTags(0) - 3, CutMarkerEnd + sErstesTagWord.Length + 1)
                Select Case TagNr
                    Case 0
                        MString = " sqrt {" & ParseCodeToMML(MString) & "} " & ParseCodeToMML(WorkString)
                    Case 1, 2, 3
                        MString = " sqrt {" & ParseCodeToMML(MString) & "} "
                End Select

            Case "mn"
                MString = WorkString.Remove(CutMarkerEnd - 4)
                MString = MString.Remove(CounterOTags(0) - 3, sErstesTag.Length + 4)
                WorkString = WorkString.Remove(CounterOTags(0) - 3, CutMarkerEnd + sErstesTagWord.Length + 1)
                Select Case TagNr
                    Case 0
                        MString = ParseCodeToMML(MString) & ParseCodeToMML(WorkString)
                    Case 1, 2, 3
                        MString = ParseCodeToMML(MString)
                End Select
            Case "mo", "mo stretchy=" & Chr(34) & "true" & Chr(34) & " accent=" & Chr(34) & "true" & Chr(34)
                MString = WorkString.Remove(CutMarkerEnd - 4)
                MString = MString.Remove(CounterOTags(0) - 3, sErstesTag.Length + 4)
                WorkString = WorkString.Remove(CounterOTags(0) - 3, CutMarkerEnd + sErstesTagWord.Length + 1)
                Select Case TagNr
                    Case 0
                        MString = ParseCodeToMML(MString) & ParseCodeToMML(WorkString)
                    Case 1, 2, 3
                        MString = ParseCodeToMML(MString)
                End Select

            Case "msubsup"
                MString = WorkString.Remove(CutMarkerEnd - 4)
                MString = MString.Remove(0, sErstesTag.Length + 4)
                WorkString = WorkString.Remove(0, CutMarkerEnd + sErstesTagWord.Length + 1)
                MStringBuffer = MString
                Select Case TagNr
                    Case 0
                        MString = ParseCodeToMML(MString, 1) & "_{" & ParseCodeToMML(MString, 2) & "}^{" & ParseCodeToMML(MString, 3) & "} " & ParseCodeToMML(WorkString)
                    Case 1, 2, 3
                        MString = ParseCodeToMML(MString, 1) & "_{" & ParseCodeToMML(MString, 2) & "}^" & ParseCodeToMML(MString, 3) & "} "
                End Select

            Case "munderover"
                MString = WorkString.Remove(CutMarkerEnd - 4)
                MString = MString.Remove(0, sErstesTag.Length + 4)

                WorkString = WorkString.Remove(0, CutMarkerEnd + sErstesTagWord.Length + 1)
                MStringBuffer = MString
                Select Case ParseCodeToMML(MString, 1)
                    Case ChrW(8747)
                        Select Case TagNr
                            Case 0
                                MString = " int csub{" & ParseCodeToMML(MString, 2) & "} csup{" & ParseCodeToMML(MString, 3) & "} " & ParseCodeToMML(WorkString)

                            Case 1, 2, 3
                                MString = " int csub{" & ParseCodeToMML(MString, 2) & "} csup{" & ParseCodeToMML(MString, 3) & "} "
                        End Select
                    Case ChrW(8748)
                        Select Case TagNr
                            Case 0
                                MString = " iint csub{" & ParseCodeToMML(MString, 2) & "} csup{" & ParseCodeToMML(MString, 3) & "} " & ParseCodeToMML(WorkString)

                            Case 1, 2, 3
                                MString = " iint csub{" & ParseCodeToMML(MString, 2) & "} csup{" & ParseCodeToMML(MString, 3) & "} "
                        End Select
                    Case ChrW(8749)
                        Select Case TagNr
                            Case 0
                                MString = " iiint csub{" & ParseCodeToMML(MString, 2) & "} csup{" & ParseCodeToMML(MString, 3) & "} " & ParseCodeToMML(WorkString)

                            Case 1, 2, 3
                                MString = " iiint csub{" & ParseCodeToMML(MString, 2) & "} csup{" & ParseCodeToMML(MString, 3) & "} "
                        End Select
                    Case ChrW(8750)
                        Select Case TagNr
                            Case 0
                                MString = " lint csub{" & ParseCodeToMML(MString, 2) & "} csup{" & ParseCodeToMML(MString, 3) & "} " & ParseCodeToMML(WorkString)

                            Case 1, 2, 3
                                MString = " lint csub{" & ParseCodeToMML(MString, 2) & "} csup{" & ParseCodeToMML(MString, 3) & "} "
                        End Select                        
                    Case ChrW(8751)
                        Select Case TagNr
                            Case 0
                                MString = " llint csub{" & ParseCodeToMML(MString, 2) & "} csup{" & ParseCodeToMML(MString, 3) & "} " & ParseCodeToMML(WorkString)

                            Case 1, 2, 3
                                MString = " llint csub{" & ParseCodeToMML(MString, 2) & "} csup{" & ParseCodeToMML(MString, 3) & "} "
                        End Select
                    Case ChrW(8752)
                        Select Case TagNr
                            Case 0
                                MString = " lllint csub{" & ParseCodeToMML(MString, 2) & "} csup{" & ParseCodeToMML(MString, 3) & "} " & ParseCodeToMML(WorkString)

                            Case 1, 2, 3
                                MString = " lllint csub{" & ParseCodeToMML(MString, 2) & "} csup{" & ParseCodeToMML(MString, 3) & "} "
                        End Select
                    Case ChrW(8721)
                        Select Case TagNr
                            Case 0
                                MString = " sum csub{" & ParseCodeToMML(MString, 2) & "} csup{" & ParseCodeToMML(MString, 3) & "} " & ParseCodeToMML(WorkString)

                            Case 1, 2, 3
                                MString = " sum csub{" & ParseCodeToMML(MString, 2) & "} csup{" & ParseCodeToMML(MString, 3) & "} "
                        End Select
                End Select

            Case "msup"
                MString = WorkString.Remove(CutMarkerEnd - 4)
                MString = MString.Remove(0, sErstesTag.Length + 4)
                WorkString = WorkString.Remove(0, CutMarkerEnd + sErstesTagWord.Length + 1)
                Select Case TagNr
                    Case 0
                        MString = ParseCodeToMML(MString, 1) & "^{" & ParseCodeToMML(MString, 2) & "} " & ParseCodeToMML(WorkString)
                    Case 1, 2, 3
                        MString = ParseCodeToMML(MString, 1) & "^{" & ParseCodeToMML(MString, 2) & "} "
                End Select
            Case "munder"
                MString = WorkString.Remove(CutMarkerEnd - 4)
                MString = MString.Remove(0, sErstesTag.Length + 4)
                WorkString = WorkString.Remove(0, CutMarkerEnd + sErstesTagWord.Length + 1)
                Select Case TagNr
                    Case 0
                        MString = ParseCodeToMML(MString, 1) & " from{" & ParseCodeToMML(MString, 2) & "} " & ParseCodeToMML(WorkString)
                    Case 1, 2, 3
                        MString = ParseCodeToMML(MString, 1) & " from{" & ParseCodeToMML(MString, 2) & "} "
                End Select
            Case "mo mathvariant=" & Chr(34) & "normal" & Chr(34)
                MString = WorkString.Remove(CutMarkerEnd - 4)
                MString = MString.Remove(0, sErstesTag.Length + 4)
                WorkString = WorkString.Remove(0, CutMarkerEnd + sErstesTagWord.Length + 1)
                Select Case ParseCodeToMML(MString)
                    Case "cos"
                        Select Case TagNr
                            Case 0
                                MString = " cos " & ParseCodeToMML(WorkString)
                            Case 1, 2, 3
                                MString = " cos "
                        End Select
                    Case "arccos"
                        Select Case TagNr
                            Case 0
                                MString = " arccos " & ParseCodeToMML(WorkString)
                            Case 1, 2, 3
                                MString = " arccos "
                        End Select
                    Case "tanh"
                        Select Case TagNr
                            Case 0
                                MString = " tanh " & ParseCodeToMML(WorkString)
                            Case 1, 2, 3
                                MString = " tanh "
                        End Select
                    Case "sin"
                        Select Case TagNr
                            Case 0
                                MString = " sin " & ParseCodeToMML(WorkString)
                            Case 1, 2, 3
                                MString = " sin "
                        End Select
                    Case "tan"
                        Select Case TagNr
                            Case 0
                                MString = " tan " & ParseCodeToMML(WorkString)
                            Case 1, 2, 3
                                MString = " tan "
                        End Select
                End Select

            Case "mover accent=" & Chr(34) & "true" & Chr(34), "mover", "mover stretchy=" & Chr(34) & "true" & Chr(34) & " accent=" & Chr(34) & "true" & Chr(34)
                MString = WorkString.Remove(CutMarkerEnd - 4)
                MString = MString.Remove(0, sErstesTag.Length + 4)
                WorkString = WorkString.Remove(0, CutMarkerEnd + sErstesTagWord.Length + 1)
                Select Case ParseCodeToMML(MString, 2)
                    Case ChrW(8594)
                        Select Case TagNr
                            Case 0
                                MString = " widevec{" & ParseCodeToMML(MString, 1) & "} " & ParseCodeToMML(WorkString)
                            Case 1, 2, 3
                                MString = " widevec{" & ParseCodeToMML(MString, 1) & "} "
                        End Select
                    Case "^"
                        Select Case TagNr
                            Case 0
                                MString = " widehat{" & ParseCodeToMML(MString, 1) & "} " & ParseCodeToMML(WorkString)
                            Case 1, 2, 3
                                MString = " widehat{" & ParseCodeToMML(MString, 1) & "} "
                        End Select
                    Case "~"
                        Select Case TagNr
                            Case 0
                                MString = " widetilde{" & ParseCodeToMML(MString, 1) & "} " & ParseCodeToMML(WorkString)
                            Case 1, 2, 3
                                MString = " widetilde{" & ParseCodeToMML(MString, 1) & "} "
                        End Select
                    Case "¨"
                        Select Case TagNr
                            Case 0
                                MString = " ddot{" & ParseCodeToMML(MString, 1) & "} " & ParseCodeToMML(WorkString)
                            Case 1, 2, 3
                                MString = " ddot{" & ParseCodeToMML(MString, 1) & "} "
                        End Select
                    Case "."
                        Select Case TagNr
                            Case 0
                                MString = " dot{" & ParseCodeToMML(MString, 1) & "} " & ParseCodeToMML(WorkString)
                            Case 1, 2, 3
                                MString = " dot{" & ParseCodeToMML(MString, 1) & "} "
                        End Select
                    Case "-"
                        Select Case TagNr
                            Case 0
                                MString = "\bar{" & ParseCodeToMML(MString, 1) & "} " & ParseCodeToMML(WorkString)
                            Case 1, 2, 3
                                MString = "\bar{" & ParseCodeToMML(MString, 1) & "} "
                        End Select
                End Select

            Case "msub"
                MString = WorkString.Remove(CutMarkerEnd - 4)
                MString = MString.Remove(0, sErstesTag.Length + 4)
                WorkString = WorkString.Remove(0, CutMarkerEnd + sErstesTagWord.Length + 1)
                Select Case TagNr
                    Case 0
                        MString = ParseCodeToMML(MString, 1) & "_{" & ParseCodeToMML(MString, 2) & "}" & ParseCodeToMML(WorkString)
                    Case 1, 2, 3
                        MString = ParseCodeToMML(MString, 1) & "_{" & ParseCodeToMML(MString, 2) & "}"
                End Select

            Case "mfrac"
                MString = WorkString.Remove(CutMarkerEnd - 4)
                MString = MString.Remove(0, sErstesTag.Length + 4)
                WorkString = WorkString.Remove(0, CutMarkerEnd + sErstesTagWord.Length + 1)
                Select Case TagNr
                    Case 0
                        MString = "{" & ParseCodeToMML(MString, 1) & "} over {" & ParseCodeToMML(MString, 2) & "}" & ParseCodeToMML(WorkString)
                    Case 1, 2, 3
                        MString = "{" & ParseCodeToMML(MString, 1) & "} over {" & ParseCodeToMML(MString, 2) & "}"
                End Select
            Case "mroot"
                MString = WorkString.Remove(CutMarkerEnd - 4)
                MString = MString.Remove(0, sErstesTag.Length + 4)
                WorkString = WorkString.Remove(0, CutMarkerEnd + sErstesTagWord.Length + 1)
                Select Case TagNr
                    Case 0
                        MString = " nroot {" & ParseCodeToMML(MString, 2) & "} {" & ParseCodeToMML(MString, 1) & "} " & ParseCodeToMML(WorkString)
                    Case 1, 2, 3
                        MString = " nroot {" & ParseCodeToMML(MString, 2) & "} {" & ParseCodeToMML(MString, 1) & "} "
                End Select
                '    Case "mtd"
                '        MString = WorkString.Remove(CutMarkerEnd - 4)
                '        MString = MString.Remove(0, sErstesTag.Length + 4)
                '        WorkString = WorkString.Remove(0, CutMarkerEnd + sErstesTagWord.Length + 1)
                '        Select Case TagNr
                '            Case 0
                '                MString = parsecodetomml(MString) & "&" & parsecodetomml(WorkString)
                '            Case 1, 2, 3
                '                MString = parsecodetomml(MString) & "&"
                '        End Select
                '    Case "mtr"
                '        MString = WorkString.Remove(CutMarkerEnd - 4)
                '        MString = MString.Remove(0, sErstesTag.Length + 4)
                '        WorkString = WorkString.Remove(0, CutMarkerEnd + sErstesTagWord.Length + 1)
                '        Select Case TagNr
                '            Case 0
                '                MString = parsecodetomml(MString) & "\cr" & parsecodetomml(WorkString)
                '            Case 1, 2, 3
                '                MString = parsecodetomml(MString) & "\cr"
                '        End Select
                '    Case "mtable"
                '        MString = WorkString.Remove(CutMarkerEnd - 4)
                '        MString = MString.Remove(0, sErstesTag.Length + 4)
                '        WorkString = WorkString.Remove(0, CutMarkerEnd + sErstesTagWord.Length + 1)
                '        Select Case TagNr
                '            Case 0
                '                MString = "\matrix{" & parsecodetomml(MString) & "}" & parsecodetomml(WorkString)
                '            Case 1, 2, 3
                '                MString = "\matrix{" & parsecodetomml(MString) & "}"
                '        End Select
            Case Else

                Dim oChar As String = MString
                If oChar.Length > 1 Then
                    oChar = oChar.Remove(1)
                End If

                Select Case oChar
                    Case "l"
                        If MString = "lim" Then
                            MString = "\lim"
                        End If
                        '    'Case ChrW(8747)
                        '    '    MString = "\int"
                        '            Case ChrW(176)
                        '                MString = "^\circ "
                    Case ChrW(177)
                        MString = "+-"
                    Case ChrW(8734)
                        MString = " infty "
                    Case ChrW(8289)
                        MString = ""
                    Case ChrW(8518)
                        MString = "d"
                    Case ChrW(945)
                        MString = "%alpha "
                    Case ChrW(946)
                        MString = "%beta "
                    Case ChrW(967)
                        MString = "%chi "
                    Case ChrW(948)
                        MString = "%delta "
                    Case ChrW(949)
                        MString = "%epsilon "
                    Case ChrW(981)
                        MString = "%phi "
                    Case ChrW(966)
                        MString = "%varphi "
                    Case ChrW(947)
                        MString = "%gamma "
                    Case ChrW(951)
                        MString = "%eta "
                    Case ChrW(953)
                        MString = "%jota "
                    Case ChrW(954)
                        MString = "%kappa "
                    Case ChrW(955)
                        MString = "%lambda "
                    Case ChrW(956)
                        MString = "%my "
                    Case ChrW(957)
                        MString = "%ny "
                    Case ChrW(960)
                        MString = "%pi "
                    Case ChrW(952)
                        MString = "%theta "
                    Case ChrW(977)
                        MString = "%vartheta "
                    Case ChrW(961)
                        MString = "%rho "
                    Case ChrW(963)
                        MString = "%sigma "
                    Case ChrW(962)
                        MString = "%varsigma "
                    Case ChrW(964)
                        MString = "%tau "
                    Case ChrW(958)
                        MString = "%xi "
                    Case ChrW(969)
                        MString = "%omega "
                    Case ChrW(968)
                        MString = "%psi "
                    Case ChrW(950)
                        MString = "%zeta "
                    Case ChrW(916)
                        MString = "%DELTA "
                    Case ChrW(934)
                        MString = "%PHI "
                    Case ChrW(915)
                        MString = "%GAMMA "
                    Case ChrW(923)
                        MString = "%LAMBDA "
                    Case ChrW(928)
                        MString = "%PI "
                    Case ChrW(920)
                        MString = "%THETA "
                    Case ChrW(931)
                        MString = "%SIGMA "
                    Case ChrW(937)
                        MString = "%OMEGA "
                    Case ChrW(926)
                        MString = "%XI "
                    Case ChrW(936)
                        MString = "%PSI "
                    Case ChrW(8804)
                        MString = "<="
                    Case ChrW(8805)
                        MString = ">="
                    Case ChrW(8810)
                        MString = "<<"
                    Case ChrW(8811)
                        MString = ">>"
                    Case ChrW(8704)
                        MString = " forall "
                    Case ChrW(8709)
                        MString = " emptyset "
                    Case ChrW(8707)
                        MString = " exists "
                        '            Case ChrW(8519)
                        '                MString = "e"
                        '            Case ChrW(8520)
                        '                MString = "i"
                    Case ChrW(8594)
                        MString = " toward "
                    Case ChrW(8712)
                        MString = " in "
                    Case ChrW(8715)
                        MString = " ni "
                    Case ChrW(8713)
                        MString = " notin "
                    Case ChrW(8463)
                        MString = " hbar "
                    Case ChrW(8469)
                        MString = " setn "
                    Case ChrW(8450)
                        MString = " setc "
                    Case ChrW(8484)
                        MString = " setz "
                    Case ChrW(8474)
                        MString = " setq"
                    Case ChrW(8477)
                        MString = " setr "
                    Case ChrW(8834)
                        MString = " subset "
                    Case ChrW(8835)
                        MString = " supset "
                    Case ChrW(8836)
                        MString = " nsubset "
                    Case ChrW(8837)
                        MString = " nsupset "
                    Case ChrW(8838)
                        MString = " subseteq "
                    Case ChrW(8839)
                        MString = " supseteq "
                    Case ChrW(8840)
                        MString = " nsubseteq "
                    Case ChrW(8841)
                        MString = " nsupseteq "
                    Case ChrW(8745)
                        MString = " union "
                    Case ChrW(8746)
                        MString = " intersection "
                    Case ChrW(172)
                        MString = " neg "
                    Case ChrW(8801)
                        MString = " equiv "
                    Case ChrW(8776)
                        MString = " approx "
                    Case ChrW(8773)
                        MString = " simeq "
                    Case ChrW(8733)
                        MString = " prop "
                    Case ChrW(8800)
                        MString = "<>"
                    Case ChrW(8901)
                        MString = " cdot "
                    Case ChrW(215)
                        MString = " times "
                    Case ChrW(8658)
                        MString = " drarrow "
                    Case ChrW(8656)
                        MString = " dlarrow "
                    Case ChrW(8660)
                        MString = " dlrarrow "
                        '            Case ChrW(8614)
                        '                MString = "\mapsto "
                        '            Case ChrW(8737)
                        '                MString = "\measuredangle "
                    Case ChrW(8706)
                        MString = " partial "
                    Case ChrW(8711)
                        MString = " nabla "
                    Case "&"
                        Select Case MString

                            Case "&lt;"
                                MString = "<"
                            Case "&gt;"
                                MString = ">"

                        End Select
                End Select
                Return MString
        End Select
                Return MString
    End Function

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        'LoadMMLCode()
        'LatexString = CropString(InpStr)
        'LatexString = ParseCodeToMML(LatexString)
        'My.Computer.Clipboard.SetText(LatexString)

        Dim dataObj As IDataObject = Clipboard.GetDataObject()
        If dataObj.GetDataPresent("MathML") Then 'bekommt einen system.io.memorystream
            LoadMMLCode()
            LatexString = CropString(InpStr)
            LatexString = ParseCodeToMML(LatexString)
            LatexString = LatexString.Remove(LatexString.Length - 3)
            My.Computer.Clipboard.SetText(LatexString)
        End If
    End Sub
    
    
End Class